#ifndef frgb_H
#define frgb_H

/* frgb.h - floating-point RGB color data type */
/* Last edited on 2006-12-01 13:32:57 by stolfi */

#include <values.h>

/* Channels in a color image: */
#define frgb_CHANNELS 3

typedef struct frgb_t { float c[frgb_CHANNELS]; } frgb_t;
  /* An RGB triplet. */

#ifndef INF
#define INF (HUGE_VAL) 
#endif

#define frgb_Black   (frgb_t){{0.0, 0.0, 0.0}}
#define frgb_White   (frgb_t){{1.0, 1.0, 1.0}}
#define frgb_Ones    (frgb_t){{1.0, 1.0, 1.0}}
#define frgb_NoColor (frgb_t){{INF, INF, INF}}

#endif
